# An Ultimate Compilation of AI Resources for Mathematics, Machine Learning and Deep Learning

## _Knowledge Not Shared is wasted. - Clan Jacobs_

### This collection is a compilation of Excellent ML and DL Tutorials created by the people below

- [Andrej Karpathy blog](http://karpathy.github.io/)
- [Brandon Roher](https://e2eml.school/blog.html)
- [Andrew Trask](https://iamtrask.github.io/)
- [Jay Alammar](https://jalammar.github.io/)
- [Sebastian Ruder](https://ruder.io/)
- [Distill](https://distill.pub/)
- [StatQuest with Josh Starmer](https://www.youtube.com/user/joshstarmer)
- [sentdex](https://www.youtube.com/channel/UCfzlCWGWYyIQ0aLC5w48gBQ)
- [Lex Fridman](https://www.youtube.com/user/lexfridman)
- [3Blue1Brown](https://www.youtube.com/channel/UCYO_jab_esuFRV4b17AJtAw)
- [Alexander Amini](https://www.youtube.com/user/Zan560)
- [The Coding Train](https://www.youtube.com/user/shiffman)
- [Christopher Olah](https://colah.github.io/)
## Communities to Follow

- [AI Coimbatore](https://www.meetup.com/AICoimbatore/) *Join here*🔗⬇️
  - [Telegram : For Daily Updates](https://t.me/joinchat/MmtTDRUcEqIuAPpr6Ph0Jw)
  - [Facebook : Coimbatore School of AI](https://www.facebook.com/groups/440187506472896/)
- [TensorFlow User Group Coimbatore](https://www.tensorflow.org/community/groups)
  - [Meetup : TFUGCbe](https://www.meetup.com/TFUGCbe/)
  - [Facebook : TFUGCbe](https://www.facebook.com/groups/2425901487658992/)

## This Repo is Created and Maintained by

_Navaneeth Malingan_

<a target="_blank" href="https://www.instagram.com/nivu.me/">
  <img align="left" alt="Instagram" width="22px" src="https://raw.githubusercontent.com/gauravghongde/social-icons/master/SVG/Color/Instagram.svg" />
</a>

<a target="_blank" href="https://www.linkedin.com/in/nivu/">
  <img align="left" alt="LinkdeIN" width="22px" src="https://raw.githubusercontent.com/gauravghongde/social-icons/master/SVG/Color/LinkedIN.svg" />
</a>
<br/>

## Why Data Science and how to get started?

- [🖥️ HOW TO GET STARTED WITH MACHINE LEARNING!](https://www.youtube.com/watch?v=I74ymkoNTnw)
- [How to Build a Meaningful Career in Data Science](https://www.datacamp.com/community/blog/how-to-build-a-meaningful-career-in-data-science)
- [My Self-Created Artificial Intelligence Masters Degree](https://hackernoon.com/my-self-created-ai-masters-degree-ddc7aae92d0e)
- [PyImageSearch](https://www.pyimagesearch.com/start-here/)
- [5 Beginner Friendly Steps to Learn Machine Learning and Data Science with Python](https://www.mrdbourke.com/5-beginner-friendly-steps-to-learn-machine-learning/)


## Intro to ML

- [Luis Serrano: A Friendly Introduction to Machine Learning](https://www.youtube.com/watch?v=IpGxLWOIZy4)
- [StatQuest: A Gentle Introduction to Machine Learning](https://www.youtube.com/watch?v=Gv9_4yMHFhI)
- [Machine Learning For Everyone](https://vas3k.com/blog/machine_learning/) _Summarize's Machine Learning algorithms and their applications in simple words with real-world examples._

## Anyone can do Machine Learning

- [Teachable Machine](https://teachablemachine.withgoogle.com/) _Train a computer to recognize your own images, sounds, & poses. A fast, easy way to create machine learning models for your sites, apps, and more – no expertise or coding required._

## MOOCs

- [Machine Learning by Andrew Ng, Stanford](https://www.coursera.org/learn/machine-learning) _IMDB 10/10 LOL :P_
- [Datacamp : Data Engineer with Python](https://www.datacamp.com/tracks/data-engineer-with-python)
- [Intro to Machine Learning](https://classroom.udacity.com/courses/ud120) _Topics Covered Naive Bayes, SVM, Decision Trees, Regressions, Outliers, Clustering, Feature Scaling, Text Learning, Feature Selection, PCA, Validation, Evaluation Metrics_
- [Intro to TensorFlow for Deep Learning](https://classroom.udacity.com/courses/ud187) _The Best Course for Learning TensorFlow_
- [End-to-End Machine Learning](https://end-to-end-machine-learning.teachable.com/courses/)
- [NVIDIA DEEP LEARNING INSTITUTE](https://www.nvidia.com/en-us/deep-learning-ai/education/)
- [Introduction to Machine Learning for Coders!](http://course18.fast.ai/ml)
- [Practical Deep Learning for Coders, v3](https://course.fast.ai/)
- [FastAI](https://www.fast.ai/)

## Courses from Top Universities
  ### Stanford University
  - [CS221 - Artificial Intelligence: Principles and Techniques by Percy Liang and Dorsa Sadigh](https://www.youtube.com/playlist?list=PLoROMvodv4rOca_Ovz1DvdtWuz8BfSWL2)
  - [CS229 - Machine Learning by Andrew Ng](https://www.youtube.com/playlist?list=PLoROMvodv4rMiGQp3WXShtMGgzqpfVfbU)
  - [CS230 - Deep Learning by Andrew Ng](https://www.youtube.com/playlist?list=PLoROMvodv4rOABXSygHTsbvUz4G_YQhOb)
  - [CS231n - Convolutional Neural Networks for Visual Recognition by Fei-Fei Li and Andrej Karpathy](https://www.youtube.com/playlist?list=PL3FW7Lu3i5JvHM8ljYj-zLfQRF3EO8sYv)
  - [CS224n - Natural Language Processing with Deep Learning by Christopher Manning](https://www.youtube.com/playlist?list=PLoROMvodv4rOSH4v6133s9LFPRHjEmbmJ)
  - [CS234 - Reinforcement Learning by Emma Brunskill](https://www.youtube.com/playlist?list=PLoROMvodv4rOSOPzutgyCTapiGlY2Nd8u)
  - [ CS330 - Deep Multi-task and Meta Learning by Chelsea Finn](https://www.youtube.com/playlist?list=PLoROMvodv4rNjRoawgt72BBNwL2V7doGI)
  - [CS25 - Transformers United](https://www.youtube.com/playlist?list=PLoROMvodv4rNiJRchCzutFw5ItR_Z27CM)

  ### Carnegie Mellon University
  - [CS/LTI 11-711: Advanced NLP by Graham Neubig](https://www.youtube.com/playlist?list=PL8PYTP1V4I8D0UkqW2fEhgLrnlDW9QK7z)
  - [CS/LTI 11-747: Neural Networks for NLP by Graham Neubig](https://www.youtube.com/playlist?list=PL8PYTP1V4I8AkaHEJ7lOOrlex-pcxS-XV)
  - [CS/LTI 11-737: Multilingual NLP by Graham Neubig](https://www.youtube.com/playlist?list=PL8PYTP1V4I8BhCpzfdKKdd1OnTfLcyZr7)
  - [CS/LTI 11-777: Multimodal Machine Learning by Louis-Philippe Morency](https://www.youtube.com/channel/UCqlHIJTGYhiwQpNuPU5e2gg/videos)
  - [CS/LTI 11-785: Introduction to Deep Learning by Bhiksha Raj and Rita Singh](https://www.youtube.com/channel/UC8hYZGEkI2dDO8scT8C5UQA/playlists)
  - [CS/LTI Low Resource NLP Bootcamp 2020 by Graham Neubig](https://www.youtube.com/playlist?list=PL8PYTP1V4I8A1CpCzURXAUa6H4HO7PF2c)

  ### Massachusetts Institute of Technology
  - [6.S191 - Introduction to Deep Learning by Alexander Amini and Ava Amini](https://www.youtube.com/playlist?list=PLtBw6njQRU-rwp5__7C0oIVt26ZgjG9NI)
  - [6.S094 - Deep Learning by Lex Fridman](https://www.youtube.com/playlist?list=PLrAXtmErZgOeiKm4sgNOknGvNjby9efdf)
  - [6.S192 - Deep Learning for Art, Aesthetics, and Creativity by Ali Jahanian](https://www.youtube.com/playlist?list=PLCpMvp7ftsnIbNwRnQJbDNRqO6qiN3EyH)

  ### University College London
  - [COMP M050 Reinforcement Learning by David Silver](https://www.youtube.com/watch?v=2pWv7GOvuf0)


## YouTube ML Playlists

- [Machine Learning by StatQuest with Josh Starmer](https://www.youtube.com/playlist?list=PLblh5JKOoLUICTaGLRoHQDuF_7q2GfuJF)
- [Intelligence and Learning by The Coding Train](https://www.youtube.com/playlist?list=PLRqwX-V7Uu6YJ3XfHhT2Mm4Y5I99nrIKX)

## Machine Learning Glossary

- [This glossary defines general machine learning terms in a variety of domains, as well as terms specific to TensorFlow.](https://developers.google.com/machine-learning/glossary)

## Machine Learning Fundamentals _(These terms will be often used in the below algorithms)_

- [Bias and Variance](https://www.youtube.com/watch?v=EuBBz3bI-aA)
- [Cross Validation](https://www.youtube.com/watch?v=fSytzGwwBVw)
- [Machine Learning Fundamentals: The Confusion Matrix](https://www.youtube.com/watch?v=Kdsp6soqA7o)
- [Sensitivity and Specivicity](https://www.youtube.com/watch?v=sunUKFXMHGk)
- [ROC and AUC, Clearly Explained!](https://www.youtube.com/watch?v=4jRBRDbJemM)
- [StatQuest: R-squared explained](https://www.youtube.com/watch?v=2AQKmw14mHM)
- [Regularization Part 1: Ridge Regression](https://www.youtube.com/watch?v=Q81RR3yKn30)
- [Regularization Part 2: Lasso Regression](https://www.youtube.com/watch?v=NGf0voTMlcs)
- [Maximum Likelihood](https://www.youtube.com/watch?v=XepXtl9YKwc)
- [Covariance and Correlation Part 1: Covariance](https://www.youtube.com/watch?v=qtaqvPAeEJY)
- [Statistics Fundamentals: The Mean, Variance and Standard Deviation](https://www.youtube.com/watch?v=SzZ6GpcfoQY)
- [Statistics Fundamentals: Population Parameters](https://www.youtube.com/watch?v=vikkiwjQqfU)
- [Glossary: Statistics](https://github.com/nature-of-code/NOC-S17-2-Intelligence-Learning/wiki/Glossary:-Statistics)
- [Glossary: Machine Learning](https://github.com/nature-of-code/NOC-S17-2-Intelligence-Learning/wiki/Glossary:-Machine-Learning)
- [Looking at R-Squared](https://medium.com/@erika.dauria/looking-at-r-squared-721252709098)

## Math

- [Mathematics for Machine Learning](https://nivu.me/posts/mathematics-for-machine-learning/) _In this post I have compiled great e-resources (MOOC, YouTube Lectures, Books) for learning Mathematics for Machine Learning._
- [Mathematics for Machine Learning - Book](https://mml-book.github.io/) One great book for all things math for machine learning. (free eBook) 
- **I highly Recommend you to go through the following resources by 3Blue1Brown**
  - [Essence of Linear Algrbra](https://www.youtube.com/playlist?list=PLZHQObOWTQDPD3MizzM2xVFitgF8hE_ab)▶️
  - [Essene of Calculus](https://www.youtube.com/playlist?list=PLZHQObOWTQDMsr9K-rj53DwVRMYO3t5Yr)▶️
  - [Differential equations](https://www.youtube.com/playlist?list=PLZHQObOWTQDNPOjrT6KVlfJuKtYTftqH6)▶️
- [Gilbert Strang: Linear Algebra vs Calculus](https://www.youtube.com/watch?v=osEADxaIKIc)▶️
- [Basics of Integral Calculus in Tamil](https://www.youtube.com/watch?v=yMQjCFvMFgA)▶️
- [New fast.ai course: Computational Linear Algebra](https://www.fast.ai/2017/07/17/num-lin-alg/)
- [Linear Algebra Book](http://www.deeplearningbook.org/contents/linear_algebra.html)

## Python

- [Python Programming Tutorials by Socratica](https://www.youtube.com/watch?v=bY6m6_IIN94&list=PLi01XoE8jYohWFPpC17Z-wWhPOSuh8Er-)▶️
- [Python Tutorial by w3schools](https://www.w3schools.com/python/)📙
- [Learning Python Programming](https://www.scaler.com/topics/python/)📙

## Numpy

- [A Visual Intro to NumPy and Data Representation](https://jalammar.github.io/visual-numpy/)
- [CS231n : Python Numpy Tutorial](http://cs231n.github.io/python-numpy-tutorial/#numpy)
- [NumPy resources : part of the End-to-End Machine Learning library](https://brohrer.github.io/numpy_resources.html)
- [100 numpy exercises (with solutions)](https://github.com/rougier/numpy-100)
- [101 NumPy Exercises for Data Analysis (Python)](https://www.machinelearningplus.com/python/101-numpy-exercises-python/)
- [Numpy Tutorial – Introduction to ndarray](https://www.machinelearningplus.com/python/numpy-tutorial-part1-array-python-examples/)
- [Sci-Py Lectures : NumPy: creating and manipulating numerical data](https://scipy-lectures.org/intro/numpy/index.html)
- [Python NumPy Tutorial for Beginners](https://www.youtube.com/watch?v=QUT1VHiLmmI)▶️ _Learn the basics of the NumPy library in this tutorial for beginners. It provides background information on how NumPy works and how it compares to Python's Built-in lists. This video goes through how to write code with NumPy. It starts with the basics of creating arrays and then gets into more advanced stuff. The video covers creating arrays, indexing, math, statistics, reshaping, and more._
- [Python NumPy Tutorial – Learn NumPy Arrays With Examples](https://www.edureka.co/blog/python-numpy-tutorial/)
- [Python Numpy Array Tutorial](https://www.datacamp.com/community/tutorials/python-numpy-tutorial)
- [NumPy Tutorial: Data analysis with Python](https://www.dataquest.io/blog/numpy-tutorial-python/)
- [Deep Learning Prerequisites: The Numpy Stack in Python](https://www.youtube.com/playlist?list=PLxgDUj5eygKmlhteKFiXIIhdqmdD2TwVM)▶️

## Pandas

- [A Gentle Visual Intro to Data Analysis in Python Using Pandas](https://jalammar.github.io/gentle-visual-intro-to-data-analysis-python-pandas/)
- [Data analysis in Python with pandas by Data School](https://www.youtube.com/watch?v=yzIMircGU5I&list=PL5-da3qGB5ICCsgW1MxlZ0Hq8LL5U3u9y)▶️
- [Best practices with pandas by Data School](https://www.youtube.com/watch?v=hl-TGI4550M&list=PL5-da3qGB5IBITZj_dYSFqnd_15JgqwA6)▶️
- [Python Pandas Tutorial: A Complete Introduction for Beginners](https://www.learndatasci.com/tutorials/python-pandas-tutorial-complete-introduction-for-beginners/)

## Machine Learning YouTube Playlists

- [CodeBasics: Machine Learning Tutorial Python](https://www.youtube.com/watch?v=gmvvaobm7eQ&list=PLeo1K3hjS3uvCeTYTeyfe0-rN5r8zn9rw)▶️
- [StatQuest: Machine Learning](https://www.youtube.com/playlist?list=PLblh5JKOoLUICTaGLRoHQDuF_7q2GfuJF)▶️
- [sentdex: Machine Learning with Python](https://www.youtube.com/playlist?list=PLQVvvaa0QuDfKTOs3Keq_kaG2P55YRn5v)▶️
- [Simplilearn: Machine Learning Tutorial Videos](https://www.youtube.com/playlist?list=PLEiEAq2VkUULYYgj13YHUWmRePqiu8Ddy)▶️
- [Machine Learning Tutorial in Python](https://www.youtube.com/playlist?list=PL9ooVrP1hQOHUfd-g8GUpKI3hHOwM_9Dn)▶️
- [deeplizard: Machine Learning & Deep Learning Fundamentals](https://www.youtube.com/playlist?list=PLZbbT5o_s2xq7LwI2y8_QtvuXZedL6tQU)▶️

## ML, DL Visual Explainers

- [MLU-EXPLAIN](https://mlu-explain.github.io/)
- [CNN Explainer](https://poloclub.github.io/cnn-explainer/)

_Note: Below you can find the best lectures for popular Machine Learning Algorithms_

## Linear Regression

- [Linear Regression: A friendly introduction by Luis Serrano](https://www.youtube.com/watch?v=wYPUhge9w5c)▶️
- [Statistics 101: Linear Regression, The Very Basics](https://www.youtube.com/watch?v=ZkjP5RJLQF4)▶️

## Logistic Regression

- [Linear Regression vs Logistic Regression | Data Science Training | Edureka](https://www.youtube.com/watch?v=OCwZyYH14uw)▶️
- [Logistic Regression and the Perceptron Algorithm: A friendly introduction by Luis Serrano](https://www.youtube.com/watch?v=jbluHIgBmBo)▶️

## Decission Tree

- [StatQuest: Decision Trees](https://www.youtube.com/watch?v=7VeUPuFGJHk)▶️
- [StatQuest: Decision Trees, Part 2 - Feature Selection and Missing Data](https://www.youtube.com/watch?v=wpNl-JwwplA)▶️
- [Decision Tree Introduction with example](https://www.geeksforgeeks.org/decision-tree-introduction-example/)📙
- [Decision Tree](https://www.geeksforgeeks.org/decision-tree/)📙
- [Python | Decision Tree Regression using sklearn](https://www.geeksforgeeks.org/python-decision-tree-regression-using-sklearn/)📙
- [ML | Logistic Regression v/s Decision Tree Classification](https://www.geeksforgeeks.org/ml-logistic-regression-v-s-decision-tree-classification/)📙

## Random Forest

- [StatQuest: Random Forests Part 1 - Building, Using and Evaluating](https://www.youtube.com/watch?v=J4Wdy0Wc_xQ)▶️
- [StatQuest: Random Forests Part 2: Missing data and clustering](https://www.youtube.com/watch?v=nyxTdL_4Q-Q)▶️
- [Random Forests for Complete Beginners](https://victorzhou.com/blog/intro-to-random-forests/)📙

## Boosting Machine Learning

- [Boosting Machine Learning Tutorial | Adaptive Boosting, Gradient Boosting, XGBoost | Edureka](https://www.youtube.com/watch?v=kho6oANGu_A)▶️
- [AdaBoost, Clearly Explained](https://www.youtube.com/watch?v=LsK-xG1cLYA)▶️
- [Gradient Boost Part 1: Regression Main Ideas](https://www.youtube.com/watch?v=3CC4N4z3GJc)▶️
- [Gradient Boost Part 2: Regression Details](https://www.youtube.com/watch?v=2xudPOBz-vs)▶️
- [Gradient Boost Part 3: Classification](https://www.youtube.com/watch?v=jxuNLH5dXCs)▶️
- [Gradient Boost Part 4: Classification Details](https://www.youtube.com/watch?v=StWY5QWMXCw)▶️
- [XGBoost Part1: XGBoost Trees for Regression](https://www.youtube.com/watch?v=OtD8wVaFm6E)▶️
- [XGBoost Part 2: XGBoost Trees For Classification](https://www.youtube.com/watch?v=8b1JEDvenQU)▶️
- [Ensemble methods Sci-kit learn](https://scikit-learn.org/stable/modules/ensemble.html)

## SVM

- [Support Vector Machines (SVMs): A friendly introduction by Luis Serrano](https://www.youtube.com/watch?v=Lpr__X8zuE8)▶️
- [Support Vector Machines, Clearly Explained!!! by StatQuest](https://www.youtube.com/watch?v=efR1C6CvhmE)▶️
- [Support Vector Machines Part 2: The Polynomial Kernel by StatQuest](https://www.youtube.com/watch?v=Toet3EiSFcM)▶️
- [Support Vector Machines Part 3: The Radial (RBF) Kernel by StatQuest](https://www.youtube.com/watch?v=Qc5IyLW_hns)▶️
- [How Support Vector Machines work / How to open a black box](https://www.youtube.com/watch?v=-Z4aojJ-pdg)▶️
- [Support Vector Machines - The Math of Intelligence (Week 1)](https://www.youtube.com/watch?v=g8D5YL6cOSE)▶️
- [Demystifying Support Vector Machines](https://towardsdatascience.com/demystifying-support-vector-machines-8453b39f7368)📙
- [Support Vector Machine (SVM) - Fun and Easy Machine Learning](https://www.youtube.com/watch?v=Y6RRHw9uN9o)▶️

## Bayes Theorem

- [Bayes theorem, and making probability intuitive](https://www.youtube.com/watch?v=HZGCoVF3YvM)▶️
- [A friendly introduction to Bayes Theorem and Hidden Markov Models](https://www.youtube.com/watch?v=kqSzLo9fenk)▶️
- [The Bayesian Trap](https://www.youtube.com/watch?v=R13BD8qKeTg)▶️
- [Naive Bayes classifier: A friendly approach](https://www.youtube.com/watch?v=Q8l0Vip5YUw)▶️

## K-Nearest Neighbors

- [KNN from Scratch](https://machinelearningmastery.com/tutorial-to-implement-k-nearest-neighbors-in-python-from-scratch/)📙
- [Machine Learning Basics with the K-Nearest Neighbors Algorithm](https://towardsdatascience.com/machine-learning-basics-with-the-k-nearest-neighbors-algorithm-6a6e71d01761)📙

## K-Means

- [StatQuest: K-means clustering](https://www.youtube.com/watch?v=4b5d3muPQmA)▶️
- [Machine Learning Tutorial Python - 13: K Means Clustering](https://www.youtube.com/watch?v=EItlUEPCIzM)▶️
- [K Means Clustering Algorithm - K Means Example in Python - Machine Learning Algorithms - Edureka](https://www.youtube.com/watch?v=1XqG0kaJVHY)▶️

## Principal Component Analysis (PCA)

- [StatQuest: PCA main ideas in only 5 minutes!!!](https://www.youtube.com/watch?v=HMOI_lkzW08)▶️
- [StatQuest: Principal Component Analysis (PCA), Step-by-Step](https://www.youtube.com/watch?v=FgakZw6K1QQ)▶️
- [Principal Component Analysis (PCA) by Luis Serrano](https://www.youtube.com/watch?v=g-Hb26agBFg)▶️

## Probabilistic Graphical Models

- [Probabilistic Graphical Models Specialization](https://www.coursera.org/specializations/probabilistic-graphical-models)

## Gradient Descent from Scratch

### The Best

- [Linear Regression using Gradient Descent](https://nivu.me/posts/linear-regression-using-gradient-descent)📙
- [Gradient Descent, Step-by-Step](https://www.youtube.com/watch?v=sDv4f4s2SB8)▶️
- [Stochastic Gradient Descent, Clearly Explained!!!](https://www.youtube.com/watch?v=vMh0zPT0tLI)▶️
- [How Optimization Works](https://end-to-end-machine-learning.teachable.com/p/building-blocks-how-optimization-works) _A short series on the fundamentals of optimization for machine learning_
- [Linear Regression using Gradient Descent](https://towardsdatascience.com/linear-regression-using-gradient-descent-97a6c8700931)
  - [Code](https://github.com/chasinginfinity/ml-from-scratch)
- [Polynomial Regression](https://towardsdatascience.com/polynomial-regression-bbe8b9d97491)
- [Gradient Descent in Linear Regression - Math](https://www.geeksforgeeks.org/gradient-descent-in-linear-regression/)📙
- [Neural Network Backpropagation Basics For Dummies](https://www.youtube.com/watch?v=8d6jf7s6_Qs)▶️

### Extra Good Ones

- [3.4: Linear Regression with Gradient Descent - Intelligence and Learning](https://www.youtube.com/watch?v=L-Lsfu4ab74)▶️
- [3.5: Mathematics of Gradient Descent - Intelligence and Learning](https://www.youtube.com/watch?v=jc2IthslyzM)▶️
- [3.5a: Calculus: Power Rule - Intelligence and Learning](https://www.youtube.com/watch?v=IKb_3FJtA1U)▶️
- [3.5b: Calculus: Chain Rule - Intelligence and Learning](https://www.youtube.com/watch?v=cE6wr0_ad8Y)▶️
- [3.5c: Calculus: Partial Derivative - Intelligence and Learning](https://www.youtube.com/watch?v=-WVBXXV81R4)▶️

### Vanishing Gradient

- [Vanishing Gradient Problem](https://www.youtube.com/watch?v=SKMpmAOUa2Q)▶️
- [How to overcome Vanishing Gradient Problem](https://www.youtube.com/watch?v=puux7KZQfsE)▶️

### How to Handle Local Minima

- https://datascience.stackexchange.com/questions/24534/does-gradient-descent-always-converge-to-an-optimum
- https://datascience.stackexchange.com/questions/18802/does-mlp-always-find-local-minimum
- https://www.coursera.org/learn/deep-neural-network/lecture/RFANA/the-problem-of-local-optima

## Scikit-learn

- [An introduction to machine learning with scikit-learn](https://scikit-learn.org/stable/tutorial/basic/tutorial.html)📙
- [Python Machine Learning: Scikit-Learn Tutorial](https://www.datacamp.com/community/tutorials/machine-learning-python)

# Deep Learning

- [DEEP BLUEBERRY BOOK](https://mithi.github.io/deep-blueberry/) _This is a tiny and very focused collection of links about deep learning. If you've always wanted to learn deep learning stuff but don't know where to start, you might have stumbled upon the right place!_
- [6.S191: Introduction to Deep Learning (2019)](http://introtodeeplearning.com/2019/)
  - [Class Lectures (YouTube) - MIT 6.S191: Introduction to Deep Learning](https://www.youtube.com/playlist?list=PLtBw6njQRU-rwp5__7C0oIVt26ZgjG9NI)
  - [Lab](https://github.com/aamini/introtodeeplearning_labs)
- [MIT 6.S191 Introduction to Deep Learning (2020)](http://introtodeeplearning.com/)
- [MIT 6.S191 Introduction to Deep Learning (2023) (YouTube)](https://youtube.com/playlist?list=PLtBw6njQRU-rwp5__7C0oIVt26ZgjG9NI)
- [MIT Deep Learning Basics: Introduction and Overview](https://www.youtube.com/watch?v=O5xeyoRL95U)
- [MIT Deep Learning by Lex Fridman](https://deeplearning.mit.edu/)
  - [Deep Learning Lectures (YouTube)](https://www.youtube.com/playlist?list=PLrAXtmErZgOeiKm4sgNOknGvNjby9efdf)
- [Deep Learning in Tamil](https://www.youtube.com/channel/UC2YVnH6aMky1SMdmlo5S9-A)

### Deep Leraning Books

- [The Deep Learning Textbook from Ian Goodfellow, Yoshua Bengio, and Aaron Courville](http://www.deeplearningbook.org/)
- [Neural Networks And Deep Learning by Michael Nielsen](http://neuralnetworksanddeeplearning.com/)
- [Grokking Deep Learning by Andrew Trask](https://www.manning.com/books/grokking-deep-learning)

### Deep Lerning Papers

- [Deep Learning Papers Reading Roadmap](https://github.com/floodsung/Deep-Learning-Papers-Reading-Roadmap)

## NN

- [A friendly introduction to Deep Learning and Neural Networks](https://www.youtube.com/watch?v=BR9h47Jtqyw)▶️
- [Machine Learning for Beginners: An Introduction to Neural Networks](https://victorzhou.com/blog/intro-to-neural-networks/)📙 _A simple explanation of how they work and how to implement one from scratch in Python._
- [A Visual and Interactive Guide to the Basics of Neural Networks](https://jalammar.github.io/visual-interactive-guide-basics-neural-networks/)📙
- [A Visual And Interactive Look at Basic Neural Network Math](https://jalammar.github.io/feedforward-neural-networks-visual-interactive/)📙
- [Neural Network Architectures](https://www.youtube.com/watch?v=oJNHXPs0XDk)▶️
- [Neural Networks Demystified by Welch Labs](https://www.youtube.com/playlist?list=PLiaHhY2iBX9hdHaRr6b7XevZtgZRa1PoU)▶️
  - [Supporting code for short YouTube series Neural Networks Demystified.](https://github.com/stephencwelch/Neural-Networks-Demystified)
- [Neural networks Series by 3Blue1Brows](https://www.youtube.com/playlist?list=PLZHQObOWTQDNU6R1_67000Dx_ZCJB-3pi)▶️

## Computer Vision

- [CS131 Computer Vision: Foundations and Applications Fall 2019](http://vision.stanford.edu/teaching/cs131_fall1920/index.html)
- [CS231A: Computer Vision, From 3D Reconstruction to Recognition Winter 2018](http://web.stanford.edu/class/cs231a/)
- [CS231n Convolutional Neural Networks for Visual Recognition](https://cs231n.github.io/)

### CNN

- [CS231n: Convolutional Neural Networks for Visual Recognition Spring 2019](http://cs231n.stanford.edu/)
- [CS231n: Convolutional Neural Networks for Visual Recognition](http://cs231n.github.io/)
- [A friendly introduction to Convolutional Neural Networks and Image Recognition](https://www.youtube.com/watch?v=2-Ol7ZB0MmU)
- [A Comprehensive Guide to Convolutional Neural Networks — the ELI5 way](https://towardsdatascience.com/a-comprehensive-guide-to-convolutional-neural-networks-the-eli5-way-3bd2b1164a53)
- [Tensorflow Convolutional Neural Network (CNN)](https://www.tensorflow.org/tutorials/images/cnn)
- [Convolutional Networks Book](http://www.deeplearningbook.org/contents/convnets.html)
- [CNNs, Part 1: An Introduction to Convolutional Neural Networks](https://victorzhou.com/blog/intro-to-cnns-part-1/)
- [CS231n Winter 2016 BY Andrej Karpathy 15 Videos](https://www.youtube.com/watch?v=NfnWJUyUJYU&list=PLkt2uSq6rBVctENoVBg1TpCC7OQi31AlC)
- [Intuitive understanding of 1D, 2D, and 3D Convolutions in Convolutional Neural Networks](https://stackoverflow.com/questions/42883547/intuitive-understanding-of-1d-2d-and-3d-convolutions-in-convolutional-neural-n)
- [CNN Explainer](https://github.com/poloclub/cnn-explainer)_An interactive visualization system designed to help non-experts learn about Convolutional Neural Networks (CNNs)_

### Object Detection

#### [Evolution Of Object Detection Networks by Cogneethi](https://www.youtube.com/playlist?list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S)
_Deep-dive tutorial on Object Detection. Intuition lectures on topics ranging from Classical CV techniques like HOG, SIFT to Convolutional Neural Network based techniques like Overfeat, Faster RCNN etc. You will learn how the ideas have evolved from some of the earliest papers to current ones. 
And hence the name Evolution of Object Detection Networks._

- [SIFT | Scale Invariant Feature Transform](https://www.youtube.com/watch?v=ttD3pvM6pEI&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=19&ab_channel=Cogneethi)
- [Hog Intuition | Histogram of Oriented Gradients](https://www.youtube.com/watch?v=Qwc3a8cOKRU&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=20&ab_channel=Cogneethi)
- [NMS | Non Max Suppression](https://www.youtube.com/watch?v=07jFApuhh4I&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=25&ab_channel=Cogneethi)
- [Object Localization | Bounding Box Regression](https://www.youtube.com/watch?v=LZRfHkTNQqo&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=49&ab_channel=Cogneethi)
- [Object Detection](https://www.youtube.com/watch?v=77XJeT-Z-uE&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=50&t=3s&ab_channel=Cogneethi)
- [RCNN](https://www.youtube.com/watch?v=dtIZVJAcLxE&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=60&t=1s&ab_channel=Cogneethi)
- [Spatial Pyramid Matching | SPM](https://www.youtube.com/watch?v=6MwuK2wHlOg&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=70&t=92s&ab_channel=Cogneethi)
- [SPPNet Object Detection](https://www.youtube.com/watch?v=M3lx8GHrEsg&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=72&ab_channel=Cogneethi)
- [Fast RCNN Network](https://www.youtube.com/watch?v=ZBPQ7Hd46m4&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=77&t=14s&ab_channel=Cogneethi)
- [Faster RCNN](https://www.youtube.com/watch?v=po59qI5LJGU&list=PL1GQaVhO4f_jLxOokW7CS5kY_J1t1T17S&index=80&ab_channel=Cogneethi)
- [Yolo v4 Object Detection - How it Works & Why it's So Amazing!](https://www.youtube.com/watch?v=_JzOFWx1vZg&t=1s&ab_channel=AugmentedStartups)
- Frameworks and Libraries
  - [Detectron2 by Facebook AI](https://github.com/facebookresearch/detectron2)
  - [MMDetection](https://github.com/open-mmlab/mmdetection)
  - [MediaPipe](https://github.com/google/mediapipe)
  - [YOLO](https://pjreddie.com/darknet/yolo/)
  - [TensorFlow Object Detection API](https://github.com/tensorflow/models/tree/master/research/object_detection)
  - [Computer Vision Recipes](https://github.com/microsoft/computervision-recipes)
- Labeling Tools
  - [LabelImg](https://github.com/tzutalin/labelImg)
  - [Roboflow](https://roboflow.com/)
  - [Label Studio](https://labelstud.io/)
- Code samples
  - [YOLO-Object-Counting-API](https://github.com/tugot17/YOLO-Object-Counting-API)

#### 3D Object Detection

- [Announcing the Objectron Dataset | Google AI Blog](https://ai.googleblog.com/2020/11/announcing-objectron-dataset.html)
- [MediaPipe Objectron | Objectron (3D Object Detection)](https://google.github.io/mediapipe/solutions/objectron.html)

### Image Segmentation

- [Computer Vision Tutorial: A Step-by-Step Introduction to Image Segmentation Techniques (Part 1)](https://www.analyticsvidhya.com/blog/2019/04/introduction-image-segmentation-techniques-python/)

### GANs

- [A Friendly Introduction to Generative Adversarial Networks (GANs) by Luis Serrano](https://www.youtube.com/watch?v=8L11aMN5KY8&ab_channel=Serrano.Academy)
- [Generative Adversarial Networks (GANs) by Ahlad Kumar](https://www.youtube.com/playlist?list=PLdxQ7SoCLQAMGgQAIAcyRevM8VvygTpCu)
- [Building our first simple GAN](https://www.youtube.com/watch?v=OljTVUVzPpM&ab_channel=AladdinPersson)
- [Face editing with Generative Adversarial Networks](https://www.youtube.com/watch?v=dCKbRCUyop8)
- [Variational Autoencoders](https://www.youtube.com/watch?v=9zKuYvjFFS8)
- [Generative Adversarial Networks (GANs) in 50 lines of code (PyTorch)](https://medium.com/@devnag/generative-adversarial-networks-gans-in-50-lines-of-code-pytorch-e81b79659e3f)
- [Generative Models](https://openai.com/blog/generative-models/)

#### Style Transfer

- [TensorFlow CNN for fast style transfer ⚡🖥🎨🖼](https://github.com/lengstrom/fast-style-transfer)

## NLP

- [CS224n: Natural Language Processing with Deep Learning](http://web.stanford.edu/class/cs224n/)
- [NLP and The Reformer](https://www.youtube.com/watch?v=rNG_hpSyZcE)
- [The Illustrated Word2vec](https://jalammar.github.io/illustrated-word2vec/)

### RNN

- [Illustrated Guide to Recurrent Neural Networks: Understanding the Intuition](https://www.youtube.com/watch?v=LHXXI4-IEns)
- [Anyone Can Learn To Code an LSTM-RNN in Python (Part 1: RNN)](https://iamtrask.github.io/2015/11/15/anyone-can-code-lstm/) _Baby steps to your neural network's first memories._
- [The Unreasonable Effectiveness of Recurrent Neural Networks](http://karpathy.github.io/2015/05/21/rnn-effectiveness/)
- [An Introduction to Recurrent Neural Networks for Beginners](https://victorzhou.com/blog/intro-to-rnns/) _A simple walkthrough of what RNNs are, how they work, and how to build one from scratch in Python._
- [Attention and Augmented Recurrent Neural Networks by Distill](https://distill.pub/2016/augmented-rnns/)
- [Visualizing memorization in RNNs by Distill](https://distill.pub/2019/memorization-in-rnns/) _Inspecting gradient magnitudes in context can be a powerful tool to see when recurrent units use short-term or long-term contextual understanding._
- [Deep Learning for NLP: ANNs, RNNs and LSTMs explained!](https://www.kdnuggets.com/2019/08/deep-learning-nlp-explained.html)

### LSTM

- [Understanding LSTM Networks](http://colah.github.io/posts/2015-08-Understanding-LSTMs/)
- [LSTM implementation explained](https://apaszke.github.io/lstm-explained.html)
- [A Gentle Introduction to LSTM Autoencoders](https://machinelearningmastery.com/lstm-autoencoders/)


### Transformers and Self Attention
#### Visual Guide to Transformer Neural Networks (Highly Recommended)

- [Part 1 -  Position Embeddings](https://www.youtube.com/watch?v=dichIcUZfOw&ab_channel=Hedu-MathofIntelligence)
- [Part 2 -  Multi-Head & Self Attention](https://www.youtube.com/watch?v=mMa2PmYJlCo&ab_channel=Hedu-MathofIntelligence)
- [Part 3 -  Decoder’s Masked Attention](https://www.youtube.com/watch?v=gJ9kaJsE78k&ab_channel=Hedu-MathofIntelligence)
- [NLP Transformers Attention Playlist](https://www.youtube.com/playlist?list=PLxI06TjqRkofnRuvD-Ks0Qef5g73yrMQ7)
- [The Illustrated Transformer](https://jalammar.github.io/illustrated-transformer/)
- [The Annotated Transformer](https://nlp.seas.harvard.edu/2018/04/03/attention.html)
- [Transformers Paper and Code](https://nn.labml.ai/transformers/index.html)
- [Transformers from Scratch](https://e2eml.school/transformers.html)
- [Transformers Notes](https://www.notion.so/Transformers-969f4b27c48147778c1e2dbda0c83ce0)
- [Transformers, Explained: Understand the Model Behind GPT-3, BERT, and T5](https://daleonai.com/transformers-explained)
- [A comprehensive overview of Transformer variants.](https://arxiv.org/abs/2106.04554)
- [How to become an NLP & Transformer Model Guru](https://www.linkedin.com/pulse/how-become-transformer-model-guru-denis-rothman/)
- [[MASTERCLASS] Transformers | Attention Models](https://youtu.be/N7u13zO8DPw)
### BERT

- [Explaining BERT Simply Using Sketches](https://mlwhiz.medium.com/explaining-bert-simply-using-sketches-ba30f6f0c8cb)
- [A Visual Guide to Using BERT for the First Time](https://jalammar.github.io/a-visual-guide-to-using-bert-for-the-first-time/)
- [The Illustrated BERT, ELMo, and co. (How NLP Cracked Transfer Learning)](https://jalammar.github.io/illustrated-bert/)
- [BERT Explained: State of the art language model for NLP](https://towardsdatascience.com/bert-explained-state-of-the-art-language-model-for-nlp-f8b21a9b6270)
- [BioBERT, a language representation model for biomedical domain, especially designed for biomedical text mining tasks such as biomedical named entity recognition, relation extraction, question answering, etc](https://github.com/dmis-lab/biobert)

### GPT

- [The Illustrated GPT-2 (Visualizing Transformer Language Models)](https://jalammar.github.io/illustrated-gpt2/)

## Reinforcement Learning

- [Deep Reinforcement Learning Course 🕹️](https://simoninithomas.github.io/Deep_reinforcement_learning_Course/) _A Free course in Deep Reinforcement Learning from beginner to expert._
- [Implementation of Reinforcement Learning Algorithms. Python, OpenAI Gym, Tensorflow. Exercises and Solutions to accompany Sutton's Book and David Silver's course.](https://github.com/dennybritz/reinforcement-learning)
- [Unity Machine Learning Agents Toolkit](https://github.com/Unity-Technologies/ml-agents)
- [🖥️ WRITING MY FIRST MACHINE LEARNING GAME! (1/4)](https://www.youtube.com/watch?v=ZX2Hyu5WoFg)
- [Deep Reinforcement Learning: Pong from Pixels by Andrej Karpathy](http://karpathy.github.io/2016/05/31/rl/)
- [A Beginner's Guide to Deep Reinforcement Learning](https://pathmind.com/wiki/deep-reinforcement-learning)
- [An Introduction to Unity ML-Agents](https://towardsdatascience.com/an-introduction-to-unity-ml-agents-6238452fcf4c)
- [Deep Reinforcement Learning Algorithms with PyTorch](https://github.com/p-christ/Deep-Reinforcement-Learning-Algorithms-with-PyTorch)
- [LECTURES: Introduction to Reinforcement Learning - David Silver](https://www.davidsilver.uk/teaching/)
- [BOOK: Reinforcement Learning - An Introduction by Sutton and Barto](https://drive.google.com/open?id=1lsBhr8H_PVnyidewtqduvV4b8wcsnAiH)
- [BOOK: Deep Reinforcement Learning Hands On by Maxim Lapan](https://drive.google.com/open?id=1YJUTUsDy2jQ_du-eoExQkk0miCT2NPRm)

## PyTorch

- [Udacity : Deep Learning with PyTorch](https://classroom.udacity.com/courses/ud188)
- [Deep Learning (PyTorch) : Code](https://github.com/udacity/deep-learning-v2-pytorch)
- [Udacity : Secure AI](https://classroom.udacity.com/courses/ud185)
- [TORCHSCRIPT](https://pytorch.org/docs/stable/jit.html)
- [PyTorchZeroToAll (in English) Sung Kim a Series of 14 Videos](https://www.youtube.com/playlist?list=PLlMkM4tgfjnJ3I-dbhO9JTw7gNty6o_2m)
  - [Supporting Code](https://github.com/hunkim/PyTorchZeroToAll)
  - [Slides](https://drive.google.com/drive/folders/0B41Zbb4c8HVyUndGdGdJSXd5d3M)

## TensorFlow

- [Introduction to TensorFlow 2.0: Easier for beginners, and more powerful for experts (TF World '19)](https://www.youtube.com/watch?v=5ECD8J3dvDQ)
- [TensorFlow Lite: Solution for running ML on-device (TF World '19)](https://www.youtube.com/watch?v=0SpZy7iouFU)
- [Machine Learning in JavaScript (TensorFlow Dev Summit 2018)](https://www.youtube.com/watch?v=YB-kfeNIPCE)
- [TensorFlow.js Quick Start](https://www.youtube.com/watch?v=Y_XM3Bu-4yc)
- [Keras vs. tf.keras: What’s the difference in TensorFlow 2.0?](https://www.pyimagesearch.com/2019/10/21/keras-vs-tf-keras-whats-the-difference-in-tensorflow-2-0/)
- [How To Run TensorFlow Lite on Raspberry Pi for Object Detection](https://www.youtube.com/watch?v=aimSGOAUI8Y)
- [How computers learn to recognize objects instantly | Joseph Redmon](https://www.youtube.com/watch?v=Cgxsv1riJhI)

### TensorFlow Courses

- [Intro to TensorFlow for Deep Learning](https://classroom.udacity.com/courses/ud187)
- [TensorFlow in Practice Specialization : Coursera](https://www.coursera.org/specializations/tensorflow-in-practice)
- [TensorFlow: Data and Deployment Specialization : Coursera](https://www.coursera.org/specializations/tensorflow-data-and-deployment)

### PyTorch Vs TensorFlow

- [Why is PyTorch becoming so popular among machine learning engineers?](https://www.quora.com/Why-is-PyTorch-becoming-so-popular-among-machine-learning-engineers)

## Transfer Learning

- [Transfer Learning with Keras and Deep Learning](https://www.pyimagesearch.com/2019/05/20/transfer-learning-with-keras-and-deep-learning/)
- [A Comprehensive Hands-on Guide to Transfer Learning with Real-World Applications in Deep Learning](https://towardsdatascience.com/a-comprehensive-hands-on-guide-to-transfer-learning-with-real-world-applications-in-deep-learning-212bf3b2f27a)
- [TensorFlow Core Tutorials](https://www.tensorflow.org/tutorials)

## Deploy Models

- [Machine Learning in 5 Minutes: How to deploy a ML model (SurveyMonkey Engineer explains)](https://www.youtube.com/watch?v=XsD2u7hAwI8)
- [Deploy Machine Learning Models with Django](https://www.deploymachinelearning.com/)
- [MlFlow - An open source platform for the machine learning lifecycle](https://mlflow.org/)
- [TensorFlow: Data and Deployment Specialization](https://www.coursera.org/specializations/tensorflow-data-and-deployment)

## MlOps

- [MLOps Primer - 2021 A collection of resources to learn about MLOps.](https://elvissaravia.substack.com/p/mlops-primer-2021)
## Code

- [codebasics/py](https://github.com/codebasics/py)
- [Google Codelabs](https://codelabs.developers.google.com/)

## CheatSheets

- [Artificial Intelligence](https://stanford.edu/~shervine/teaching/cs-221/)
- [Machine Learning](https://stanford.edu/~shervine/teaching/cs-229/)
- [Deep Learning](https://stanford.edu/~shervine/teaching/cs-230/)
- [Machine Learning tips and tricks](https://stanford.edu/~shervine/teaching/cs-229/cheatsheet-machine-learning-tips-and-tricks)
- [Data Science Tools](https://www.mit.edu/~amidi/teaching/data-science-tools/)
- [Machine Learning with R](https://www.mit.edu/~amidi/teaching/modeling/study-guide/machine-learning-with-r/)
- [CHRIS ALBON Cheat Sheets and Flash Cards](https://chrisalbon.com/)
- [MLOps Tooling Landscape v2 (+84 new tools) - Dec '20](https://huyenchip.com/2020/12/30/mlops-v2.html)
- [Mathematical tools](https://stanford.edu/~shervine/teaching/cme-102/linear-algebra)
- [Ordinary Differential Equations for Engineers](https://stanford.edu/~shervine/teaching/cme-102/cheatsheet-first-ode)


## Edge ML Kits

- [Nvidia Jetson Nano Developer Kit](https://developer.nvidia.com/embedded/jetson-nano-developer-kit)
- [Intel® Neural Compute Stick 2 (Intel® NCS2)](https://software.intel.com/en-us/neural-compute-stick)
- [Coral](https://coral.ai/)

## Data Science Competitions

- [Kaggle](https://www.kaggle.com/)

## Important Youtube🎬 Channels in the field of AI/ML/RL/DS

- [3Blue1Brown](https://www.youtube.com/channel/UCYO_jab_esuFRV4b17AJtAw)
- [StatQuest with Josh Starmer](https://www.youtube.com/user/joshstarmer)
- [Sentdex](https://www.youtube.com/user/sentdex)
- [Luis Serrano](https://www.youtube.com/channel/UCgBncpylJ1kiVaPyP-PZauQ)
- [Brandon Rohrer](https://www.youtube.com/user/BrandonRohrer)
- [deeplizard](https://www.youtube.com/channel/UC4UJ26WkceqONNF5S26OiVw)
- [Tech With Tim](https://www.youtube.com/channel/UC4JX40jDee_tINbkjycV4Sg)
- [Microsoft Research](https://www.youtube.com/user/MicrosoftResearch)
- [Corey Schafer](https://www.youtube.com/user/schafer5)
- [Data School](https://www.youtube.com/user/dataschool)
- [Two Minute Papers](https://www.youtube.com/user/keeroyz)
- [Welch Labs](https://www.youtube.com/user/Taylorns34)
- [Simplilearn](https://www.youtube.com/user/Simplilearn)
- [Great Learning](https://www.youtube.com/user/beaconelearning)
- [DeepLearning.TV](https://www.youtube.com/channel/UC9OeZkIwhzfv-_Cb7fCikLQ)
- [TensorFlow](https://www.youtube.com/channel/UC0rqucBdTuFTjJiefW5t-IQ)
- [Deeplearning.ai](https://www.youtube.com/channel/UCcIXc5mJsHVYTZR1maL5l9w)
- [Code Bullet](https://www.youtube.com/channel/UC0e3QhIYukixgh5VVpKHH9Q)
- [edureka!](https://www.youtube.com/user/edurekaIN)
- [Lex Fridman](https://www.youtube.com/channel/UCSHZKyawb77ixDdsGog4iWA)
- [The Artificial Intelligence Channel](https://www.youtube.com/user/Maaaarth)
- [freeCodeCamp.org](https://www.youtube.com/channel/UC8butISFwT-Wl7EV0hUK0BQ)
- [CloudxLab](https://www.youtube.com/channel/UC8mJ6DL1Q32UWyJUceoO8Jw)
- [Alexander Amini](https://www.youtube.com/user/Zan560)
- [Jeff Heaton](https://www.youtube.com/user/HeatonResearch)
- [Abhishek Thakur](https://www.youtube.com/user/abhisheksvnit)
- [The Coding Train](https://www.youtube.com/user/shiffman)

## Reference

- [🖥️ HOW TO GET STARTED WITH MACHINE LEARNING!](https://www.youtube.com/watch?v=I74ymkoNTnw)
- [My Self-Created Artificial Intelligence Masters Degree](https://hackernoon.com/my-self-created-ai-masters-degree-ddc7aae92d0e)
- https://end-to-end-machine-learning.teachable.com/courses/667372/lectures/11900568
- [ML Fundamentals by StatQuest](https://www.youtube.com/watch?v=Gv9_4yMHFhI&list=PLblh5JKOoLUICTaGLRoHQDuF_7q2GfuJF)
- [Machine Learning with Python by sentdex](https://www.youtube.com/playlist?list=PLQVvvaa0QuDfKTOs3Keq_kaG2P55YRn5v)
- [5 Beginner Friendly Steps to Learn Machine Learning and Data Science with Python - Daniel Bourke](https://www.mrdbourke.com/5-beginner-friendly-steps-to-learn-machine-learning/)
- [Data School](https://www.dataschool.io/)
- [Neural Networks and Deep Learning](http://neuralnetworksanddeeplearning.com/)
- https://www.machinelearningisfun.com/
- https://medium.com/@ageitgey/machine-learning-is-fun-80ea3ec3c471
- https://medium.com/greyatom
- https://greyatom.com/glabs
- [John Searle: "Consciousness in Artificial Intelligence" | Talks at Google](https://www.youtube.com/watch?v=rHKwIYsPXLg)
- https://github.com/nature-of-code/NOC-S17-2-Intelligence-Learning/tree/master/week3-classification-regression
- https://github.com/nature-of-code/NOC-S17-2-Intelligence-Learning
